#ifndef __CHECKSEC_H__
#define __CHECKSEC_H__

#include "s_value.h"
#include "s_time.h"

typedef enum{CSINIT_FROM_NOW=0,
	     CSINIT_FIRST_TRUE,
	     CSINIT_FIRST_FALSE,
	     CSINIT_TRUE,
	     CSINIT_FALSE,
	     CSINIT_FORCE_TRUE,
	     CSINIT_FORCE_FALSE} csinit_mode;

/* `FbNԊu(secP) */
#define CS_WAIT_TIME		1000000UL
#define CS_HALF_WAIT_TIME	 500000UL
#define CS_SECOND_TIME		   1000UL

typedef struct {
  s_time cs_time;	// vJn
  int cs_init_mode;	// 쒆̎ԃ`FbN[h
  // 0:v(checkAw莞Ԍo߂ĂTRUEԂAȊOFALSE)
  // 1:vOFcheckTRUEԂ̎_vJn
  // 2:vOFcheckFALSEԂ̎_vJn
  // 3:TRUEԂ
  // 4:FALSEԂ
  int cs_noshorten_mode;	// c莞Ԃk邩Ȃ̃[h
  // 0:k(񈳏kԂ)
  // 1:kȂ
} cs_data;

cs_data *cs_init(cs_data *csd,csinit_mode mode);
int cs_check_usec(cs_data *csd,uint64 cswait);
void cs_fprintf_check_time(FILE *fp,cs_data *csd,char *format);

#define cs_check_sec(csd)	cs_check_usec(csd,CS_WAIT_TIME)
#define cs_check_half_sec(csd)	cs_check_usec(csd,CS_HALF_WAIT_TIME)
#define cs_check_msec(csd,a)	cs_check_usec(csd,(a)*CS_SECOND_TIME)

#define check_usec(a)		cs_check_usec(NULL,a)
#define init_check_usec(mode)		cs_init(NULL,mode)

#define check_sec()		check_usec(CS_WAIT_TIME)
#define check_half_sec()	check_usec(CS_HALF_WAIT_TIME)
#define check_msec(a)		check_usec((a)*CS_SECOND_TIME)
#define init_check_sec(mode)		init_check_usec(mode)
#define init_check_half_sec(mode)	init_check_usec(mode)
#define init_check_msec(mode)		init_check_usec(mode)

#define CS_DEFFMT	"YMD hms"

#define print_check_time()	cs_fprintf_check_time(stdout,NULL,CS_DEFFMT)

#define printf_check_time(f)	cs_fprintf_check_time(stdout,NULL,f)
#define fprint_check_time(fp)	cs_fprintf_check_time(fp,NULL,CS_DEFFMT)
#define cs_print_check_time(a)	cs_fprintf_check_time(stdout,a,CS_DEFFMT)

#define fprintf_check_time(fp,f)	cs_fprintf_check_time(fp,NULL,f)
#define cs_fprint_check_time(fp,a)	cs_fprintf_check_time(fp,a,CS_DEFFMT)
#define cs_printf_check_time(a,f)	cs_fprintf_check_time(stdout,a,f)

/************************************************************************/
#endif // _CHECKSEC_H_
