/************************************************************************
 s_sharemem TCo LTu[` Ver.1.03d
 ************************************************************************
 o
 Ver.1.00(2011/07/08)	Ƃ肠쐬B
 Ver.1.01(2011/07/15)	x_xacharˑ̔r
 Ver.1.02(2011/08/09)	is_exist_shared_memory()֐ǉAshared memory
 Ver.1.03(2012/10/24)	alloc/free_shared_memory_set()֐ǉ,UNICODEΉ
*/
/*
 L̈ȒPɂTu[`
 
 PCňقȂvZXԂŋLꍇz肵ĂB
 قȂPCԂł͋LȂ̂Œӂ邱ƁB
 
 __windows__ defineĂꍇFCreateFileMappinggp
 ̑(unixn)Fshmgetgp
 
 POSIX̏ꍇshm_openg炵܂Ȃ̂ō폜(Ver.0.99)
 
 ID()ɂĎʂB
 IDĂvOɑ΂ē񋟂B
 TCY̎w͍ŏ̂ݗLŁAŕωꍇ͕̓ۏłȂB
 
 ƎĂ݂Ƃ
 unix̏ꍇ́AȂ镪ɂ͖ȂA傫镪alloc̎_ŃG
 [ɂȂ͗lB
 Windows̏ꍇ͏TCY̏ꍇ͔rIRɃTCYύX\B傫
 Ƃ0ŏĂB傫TCY̎unixƓlalloc
 ̎_ŃG[ɂȂ͗lB
 */
#include	"s_windows.h"
#include	"s_sharemem.h"
#include	"s_malloc.h"
#include	"s_value.h"

int is_exist_shared_memory(char id[])
{
  int ret_flag;
#ifdef __windows__
  HANDLE hd;
#else
  key_t key;
  int shrd_id;
#endif

  ret_flag = FALSE;
#ifdef __windows__
  hd = OpenFileMappingA(FILE_MAP_READ,FALSE,id);
  if(hd != NULL)
    {
      ret_flag = TRUE;
      CloseHandle(hd);
    }
#else
  key = ftok(id,NUM_ID);
  shrd_id = shmget(key, 1, 0444);
  if(shrd_id >= 0)
    {
      ret_flag = TRUE;
    }
#endif
  return(ret_flag);
}

ssm_data *alloc_shared_memory_set(ssm_data *out,
				  char id[],unsigned long long size,int mode)
{
  ssm_data *ssm;
#ifdef __windows__
  DWORD flProtect;
  DWORD dwDesiredAccess;
#else
  /* none */
#endif
  
  ssm = out;
  if(ssm == NULL) ssm = xalloc(ssm_data,1);
#ifdef __windows__
  // ftHg̐ݒ
  flProtect = PAGE_READWRITE;
  dwDesiredAccess = FILE_MAP_ALL_ACCESS;
  switch(mode)
  {
  case SSM_READONLY:
    // ԍŏREADONLYĂ܂2Ԗڈȍ~߂ȂȂ
    // flProtect = PAGE_READONLY;
    dwDesiredAccess = FILE_MAP_READ;
    break;
  case SSM_WRITEONLY:
    flProtect = PAGE_READWRITE;
    dwDesiredAccess = FILE_MAP_WRITE;
    // ۂɂ͓ǂݏo\ɂȂ͗l(READWRITE)
    break;
  case SSM_READWRITE:
  default:
    break;
  }
  ssm->hSharedMem = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, flProtect,
				       (((size)>>32) & 0xffffffff),
				       ((size) & 0xffffffff),id);
  if(ssm->hSharedMem == NULL)
  {
    printf("Error hSharedMem\n");
    if(ssm != out) free(ssm);
    ssm = NULL;
  }
  else
  {
    if(GetLastError() == ERROR_ALREADY_EXISTS)
    {
      // printf("Warning : s_sharedmem : Already Exists.\n");
      // TCY`FbNłȂȁEEE
    }
    ssm->data = MapViewOfFile(ssm->hSharedMem, dwDesiredAccess, 0, 0,
			      (size_t)size );
    if(ssm->data == NULL)
    {
      printf("MapViewOfFile Error \n");
      CloseHandle(ssm->hSharedMem); //}bvht@CN[Y  
      if(ssm != out) free(ssm);
      ssm = NULL;
    }
  }
#else
  ssm->key = ftok(id,NUM_ID);
  // printf("Debug : Try shmget\n");
  ssm->shrd_id = shmget(ssm->key, size, 0444);
  if(ssm->shrd_id < 0)
  {
    // printf("Debug : Retry shmget\n");
    ssm->shrd_id = shmget(ssm->key, size, IPC_CREAT|0666);
  }
  if(ssm->shrd_id < 0)
  {
    printf("Error shmget\n");
    free(ssm); ssm = NULL;
  }
  else
  {
    // printf("Debug : Try shmmat\n");
    ssm->data = shmat( ssm->shrd_id, NULL, 0);
    if(ssm->data == (void *)-1)
    {
      printf("Error on shmat\n");
      if(ssm != out) free(ssm);
      ssm = NULL;
    }
  }
#endif
  if(ssm != NULL)
  {
    ssm->size = (size_t)size;
    // printf("Debug : address : %x\n",ssm->data);
  }
  return(ssm);
}

// L̊S폜(IɎs)
static void force_delete_shared_memory(ssm_data *ssm)
{
#ifdef __windows__
  /* none */
#else
  if(shmctl(ssm->shrd_id, IPC_RMID, 0) != 0)
  {
    fprintf(stderr,"Warning : Can't IPC_RMID.\n");
  }
#endif
}

// L̊S폜(A^b`ĂȂ̔܂)
static void delete_shared_memory(ssm_data *ssm)
{
#ifdef __windows__
  /* none */
#else
  struct shmid_ds stat;
  if(shmctl(ssm->shrd_id, IPC_STAT, &stat) == 0)
  {
    // printf("Debug : nattach = %d\n",stat.shm_nattch);
    if(stat.shm_nattch == 0)
    {
      force_delete_shared_memory(ssm);
    }
  }
#endif
}

// L̉
int free_shared_memory_force_set(ssm_data *ssm,int force_flag,int set_flag)
{
  if(ssm==NULL) return(1);
  
  // AhX蓖Ẳ
#ifdef __windows__
  UnmapViewOfFile(ssm->data);
  CloseHandle(ssm->hSharedMem); //}bvht@CN[Y  
#else
  shmdt(ssm->data);
#endif
  
  if(force_flag)
  {
    force_delete_shared_memory(ssm);
  }
  else
  {
    delete_shared_memory(ssm);
  }
  if(!set_flag)
  {
    // ȉssm_data\̂̃
    free(ssm);
  }
  return(0);
}
