#ifndef __S_TIME_H__
#define __S_TIME_H__

#include "s_value.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

// st_mode ́Ast_str(`)ɂêŒ
typedef enum { ST_ERR=-1,
  ST_YEAR=0,ST_MONTH,ST_DAY,
  ST_HOUR,ST_MIN,ST_SEC,
  ST_MSEC,ST_USEC,
  ST_MSECP,ST_USECP,
  ST_AUTO} st_mode;

/************************************************************************/
// s_timen̊e`
/************************************************************************/
#ifdef __MSDOS__
/* ftimegp (MS-DOSp,o[WłꉞxႢ) */
/* ƎgĂȂ̂œۏ؂łȂ */
/* Iɂ͂FREE-DOSőΉlH */
#include <sys/types.h>
#include <sys/timeb.h>

typedef struct {
  struct timeb tb;
  int add;	// ~bȉtimebł͊ǗłȂ̂ŕ␳
} s_time;

void st_get_now_date(s_time *st);

#else
/************************************************************************/
#ifdef __windows__
/* GetSystemTimeAsFileTimegp (Windowsp) */
#include <windows.h>

typedef FILETIME s_time;
#define st_get_now_date(a) GetSystemTimeAsFileTime(a)

#else
/************************************************************************/
/* gettimeofday()gp (unixp) */
#include <sys/time.h>

typedef struct timeval s_time;
#define st_get_now_date(a)	gettimeofday(a,NULL)

/************************************************************************/
#endif // __windows__
#endif // __MSDOS__
/*
  ȉA@ˑ̐錾(֐͋@ʂɂȂ)
*/
// b̕\A1bɂ邽߂̐(}CNbPʂœ)
#define DIV_S_TIME	1000000
// ~bɂ邽߂̐
#define DIV_S_TIME_M	(DIV_S_TIME / 1000)
// }CNbɂ邽߂̐
#define DIV_S_TIME_U	(DIV_S_TIME / 1000000)

// ֐錾
int st_div_date(int *year,int *month,int *day,
		int *hour,int *min,int *sec,int *msec,int *usec,
		s_time *st);
int st_set_date(s_time *st,int year,int month,int day,
		int hour,int min,int sec,int msec,int usec);
int st_is_future(s_time *now,s_time *target);
uint64 st_diff_time(s_time *tstart,s_time *tend);
#define st_diff_time_uint32(ts,te)	(uint32)st_diff_time((ts),(te))
#define st_diff_time_double(ts,te)			\
  ((double)st_diff_time((ts),(te)) / DIV_S_TIME)

void st_add_time(s_time *st,uint64 add_time);
void st_sub_time(s_time *st,uint64 sub_time);

// @ˑ̊֐(time֌W)

int st_div_time(int *year, int *month, int *day,
	int *hour, int *min, int *sec, int *msec, int *usec,
	uint64 time);

void st_fprint_time_mode(FILE *fp,uint64 u64time, st_mode mode);
#define st_fprint_time_all(fp,t)	st_fprint_time_mode(fp,t,ST_AUTO)
void st_fprint_timef(FILE *fp,uint64 u64time,char *format);
#define st_fprint_time_year(fp,t)	st_fprint_timef(fp,t,"YMD hms")
#define st_fprint_time_mon(fp,t)	st_fprint_timef(fp,t,"MD hms")
#define st_fprint_time_day(fp,t)	st_fprint_timef(fp,t,"D hms")
#define st_fprint_time_hour(fp,t)	st_fprint_timef(fp,t,"hms")
#define st_fprint_time_min(fp,t)	st_fprint_timef(fp,t,"ms")
#define st_fprint_time_sec(fp,t)	st_fprint_timef(fp,t,"s")
#define st_fprint_time_msec(fp,t)	st_fprint_timef(fp,t,"si")
#define st_fprint_time_usec(fp,t)	st_fprint_timef(fp,t,"su")
#define st_fprint_time(fp,t)		st_fprint_time_msec(fp,t)

#define st_print_time_mode(t,m)		st_fprint_time_mode(stdout,t,m)
#define st_print_time_all(t,m)		st_fprint_time_all(stdout,t)
#define st_print_timef(t,format)	st_fprint_timef(stdout,t,format)
#define st_print_time_year(t)		st_fprint_time_year(stdout,t)
#define st_print_time_mon(t)		st_fprint_time_mon(stdout,t)
#define st_print_time_day(t)		st_fprint_time_day(stdout,t)
#define st_print_time_hour(t)		st_fprint_time_hour(stdout,t)
#define st_print_time_min(t)		st_fprint_time_min(stdout,t)
#define st_print_time_sec(t)		st_fprint_time_sec(stdout,t)
#define st_print_time_msec(t)		st_fprint_time_msec(stdout,t)
#define st_print_time_usec(t)		st_fprint_time_usec(stdout,t)
#define st_print_time(t)		st_fprint_time(stdout,t)

uint64 st_get_now_time(s_time *st);
#define st_get_now_time_uint32(st)	(uint32)st_get_now_time(st)
#define st_get_now_time_sec_float(st)		\
  ((float)st_get_now_time(st) / DIV_S_TIME)
#define st_get_now_time_sec_double(st)		\
  ((double)st_get_now_time(st) / DIV_S_TIME)

int st_get_now_time_sec_int(s_time *st);
#define st_get_now_time_sec(st)			\
  st_get_now_time_sec_int(st)

// @ˑ̊֐

// st_print_date_alĺust_print_datef(st,"YMD hmsu")Ɠ삾
void st_fprint_date_all(FILE *fp,s_time *st);
#define st_print_date_all(st)		st_fprint_date_all(stdout,st)
void st_fprint_datef(FILE *fp,s_time *st,char *format);
#define st_print_datef(st,format)	st_fprint_datef(stdout,st,format)
// ȈՕ\p֐
#define st_fprint_date_day(fp,st)	st_fprint_datef(fp,st,"YMD")
#define st_fprint_date_min(fp,st)	st_fprint_datef(fp,st,"YMD hm")
#define st_fprint_date_sec(fp,st)	st_fprint_datef(fp,st,"YMD hms")
#define st_fprint_date_msec(fp,st)	st_fprint_datef(fp,st,"YMD hmsi")
#define st_fprint_date_usec(fp,st)	st_fprint_datef(fp,st,"YMD hmsu")
#define st_fprint_date(fp,st)		st_fprint_date_sec(fp,st)
#define st_fprint_clock_min(fp,st)	st_fprint_datef(fp,st,"hm")
#define st_fprint_clock_sec(fp,st)	st_fprint_datef(fp,st,"hms")
#define st_fprint_clock_msec(fp,st)	st_fprint_datef(fp,st,"hmsi")
#define st_fprint_clock_usec(fp,st)	st_fprint_datef(fp,st,"hmsu")
#define st_fprint_clock(fp,st)		st_fprint_clock_sec(fp,st)
// Wo͗p
#define st_print_date_day(st)		st_fprint_date_day(stdout,st)
#define st_print_date_min(st)		st_fprint_date_min(stdout,st)
#define st_print_date_sec(st)		st_fprint_date_sec(stdout,st)
#define st_print_date_msec(st)		st_fprint_date_msec(stdout,st)
#define st_print_date_usec(st)		st_fprint_date_usec(stdout,st)
#define st_print_date(st)		st_fprint_date(stdout,st)
#define st_print_clock_min(st)		st_fprint_clock_min(stdout,st)
#define st_print_clock_sec(st)		st_fprint_clock_sec(stdout,st)
#define st_print_clock_msec(st)		st_fprint_clock_msec(stdout,st)
#define st_print_clock_usec(st)		st_fprint_clock_usec(stdout,st)
#define st_print_clock(fp,st)		st_fprint_clock(stdout,st)

void st_init_date(s_time *st);
#define st_init_time(st)	st_init_date(st)

void st_shift_date(s_time *st,uint64 add_time);

// }Nɂ֐ǂ

// s_timeRs[
#define st_copy_date(dst,src)	memcpy((dst),(src),sizeof(s_time))

// ȉAo[W݊pB{Iɂ͎gȂ
#if 0
#define st_calc_diff_time(ts,te)	(uint64)st_diff_time((ts),(te))
// #define st_print_date(st)		st_fprint_date_all(stdout,st)
#define st_get_time(st)	st_get_now_date(st)
#define st_copy_time(dst,src)	st_copy_date(dst,src)
#define st_check_start_time(st,add) st_shift_date(st,add);
#endif

#endif // __S_TIME_H__
