char M_TITLE[] = "Saibara's image process program for ism Ver.1.00c\n";
char M_HELP[] = "process_ism.exe <input id> <x> <y> <output id>\n";
/*
  ismf[^Ԃŉ摜 TvvO

  Ver.1.00 2012/07/31 Ƃ肠쐬
*/
#define DEF_INPUTID	"ism_in"
#define DEF_OUTPUTID	"ism_out"
#define DEF_XSIZE	0
#define DEF_YSIZE	0

#include <stdio.h>
#include <stdlib.h>
#include "s_sharemem.h"
#include "ism_data.h"
#include "s_malloc.h"

#include "msleep.f"
#include "checksec.f"
#include "s_setconsoletitle.f"

// 摜{̂main_process.cɂ
void change_data(unsigned char *buf, int size, int mx, int my);

// C֐
int main(int argc, char *argv[])
{
  char *inid, *outid;
  int x, y, size;
  ism_data *ism_in, *ism_out;
  ism_head *ismh_in;
  int count;
  char *buf;
  ism_time lasttime;

  s_setconsoletitle(argc, argv);
  fputs(M_TITLE, stdout);
  if (argc == 1)
  {
    fputs(M_HELP, stdout);
    exit(1);
  }

  inid = DEF_INPUTID;
  outid = DEF_OUTPUTID;
  x = DEF_XSIZE;
  y = DEF_YSIZE;

  if (argc > 1) { inid = argv[1]; argc--; argv++; }
  if (argc > 1) { x = atoi(argv[1]); argc--; argv++; }
  if (argc > 1) { y = atoi(argv[1]); argc--; argv++; }
  if (argc > 1) { outid = argv[1]; argc--; argv++; }

  printf("Processing ism ID '%s' -> '%s'\n", inid, outid);
  printf("Image size : %d %d\n", x, y);

  // ismm
  printf("Open Shared memory Input\n");
  ism_in = ism_alloc_image_shared_memory_rgb(inid, x, y);
  if (ism_in == NULL)
  {
    printf("Can't open share memory\n");
    exit(1);
  }

  // ߂ē͉摜TCYl
  ismh_in = ism_get_head(ism_in);
  x = ism_head_get_width(ismh_in);
  y = ism_head_get_height(ismh_in);

  printf("Image size : %d %d\n", x, y);

  // oismm
  printf("Open Shared memory Output\n");
  ism_out = ism_alloc_image_shared_memory_rgb(outid, x, y);
  if (ism_out == NULL)
  {
    printf("Can't open share memory\n");
    exit(1);
  }

  // obt@m
  size = x * y * 3;
  buf = xalloc(char, size);
  if (buf == NULL)
  {
    printf("Can't allocate memory\n");
    exit(1);
  }

  count = 0;
  ism_time_init(&lasttime);
  while (1)
  {
    if (ism_head_is_refreshed(ismh_in, &lasttime))
    {
      ism_head_get_lasttime(ismh_in,&lasttime);
      ism_copy_data(buf, ism_in);
      change_data(buf, size, x, y);
      ism_put_data(ism_out, buf, size);
      ism_update_time_now(ism_out);
      count++;
    }
    else
    {
      msleep(ISM_WAIT_UPDATE_MSEC);
    }
    if (check_sec())
    {
      printf("%d image processed.\n", count);
      count = 0;
    }
  }
  ism_free_image_shared_memory(ism_in);
  ism_free_image_shared_memory(ism_out);
}
